<?php 

class helper_image {

	public $temp_dir;
	
	public function __construct() {
		$this->temp_dir = ROOT_DIR . '/tmp/';
	}

	// v 3.0
	// переносит изображение в нужную папку, уменьшает, если требуется создает превьюшку
	// $input_name - name поля формы
	// $new_width - новая ширина
	// $new_width_thrumb - новая ширина превьюхи (0 - значит не надо)
	// $img_path - путь к изображению
	// $new_height - новая высота (обрезается если пропорционально должно быть больше)
	// $new_height_thrumb - новая высота превьюхи
	// возвращает имя изображения

	public function img_upload($input_name, $new_width, $img_path = '', $new_width_thrumb=0, $new_height_thrumb='auto', $new_height='auto') {
		$debug=true;
		$error = '';
		if(!$img_path || !is_dir($img_path)) {
			$img_path = $this->temp_dir;
		}
		// генерируем имя
		$img_name = $this->get_rand_name().'.jpg';
		// полный путь
		$img_name_full = $img_path . $img_name;
		// проверка формата изображения
		if (!isset($_FILES[$input_name]) ) {
			if($debug) {$error ='Изображение не загружено'; }
			else return '';
		}
		// проверка формата изображения
		if ($_FILES[$input_name]['type'] != "image/jpeg" AND $_FILES[$input_name]['type'] != "image/png" AND $_FILES[$input_name]['type'] != "image/gif" ) {
			if($debug) {$error .='Неправильный формат фотографий, только JPG, PNG, GIF<br>';  }
			else return false;
		}
		// проверка папки на существование
		if(!is_dir($img_path)) {
			if($debug) {$error .='Папки "'.$img_path.'" не существует.<br>';  }
			else return false;
			//mkdir($img_path);
		}
		if ( !move_uploaded_file($_FILES[$input_name]['tmp_name'], $img_name_full) ) {
			if($debug) { $error .='Не удалось переместить изображение в папку '.$img_path.' (проверьте права на запись)<br>';  }
			else return false;
		} else {
			// уменьшаем
			if ($this->img_resize($img_name_full, $img_name_full, $new_width)) {
				// обрезаем до нужной высоты если требуется
				if($new_height!='auto') {
					if( !$this->img_crop($img_name_full, $img_name_full, array(0,0,$new_width,$new_height) ) ) {
						if($debug) {$error .='Не удалось обрезать изображение<br>';  }
						else return false;
					}
				}
				// делаем превьюху
				if($new_width_thrumb!=0){
					$thrumb_name_full = $img_path .'mini/'. $img_name;  // полный путь до превьюхи
					// проверка папки на существование, если нет, создаем
					if(!is_dir($img_path .'mini/')) {
						if(!mkdir($img_path .'mini/') ) {
							if($debug) { $error .='Не удалось создать папку для превью: "'.$img_path .'mini/<br>';  }
							else return false;
						}
					}    
					// генерация
					if ($this->img_resize($img_name_full, $thrumb_name_full, $new_width_thrumb) ) {
						// обрезаем превьюху до нужной высоты если требуется
						if($new_height_thrumb!='auto') {
							if( !$this->img_crop($thrumb_name_full, $thrumb_name_full, array(0,0,$new_width_thrumb,$new_height_thrumb) ) ) {
								if($debug){$error .='Не удалось обрезать превью<br>';  }
								else return false;
							} else {
								return $img_name;
							}
						} else {
							return $img_name;
						}        
								
					} else {
						if($debug) {$error .='Не удалось уменьшить до превью<br>';  }
						else return false;
					}
				} else {
				
					return $img_name;
				}
			} else {
				if($debug) {$error .='Не удалось уменьшить до макси<br>'; }
				else return false;
			};
		}
		if(!empty($error)) {
			die ('<div class="notice error" style="font-size:30px;">'.$error.'</div>');
		}
	}
	
			
		/**
		 * v 3.0
		 * Изменение размеров изображения  (длина одной стороны генерируется пропорционально, по умолчанию высота)
		 * @param string $name_old - имя исходного файла
		 * @param string $name_new - имя генерируемого файла
		 * @param integer $new_size - новый размер генерируемого изображения (или высота или ширина)
		 * Необязательные параметры:
		 * @param integer $quality - качество генерируемого JPEG, по умолчанию - 85
		 * @param integer $auto - что считается автоматом, по умолчанию высота, значит $new_size будет шириной, если надо наоборот указываем любое другое значение, например width
		 * @return bool
		 */
	public function img_resize($name_old, $name_new, $new_size, $quality=100, $auto='height') {
		if (!file_exists($name_old)) return false;
		$size = getimagesize($name_old);
		if ($size === false) return false;
		// Определяем исходный формат по MIME-информации, предоставленной
		// функцией getimagesize, и выбираем соответствующую формату
		// imagecreatefrom-функцию.
		$format = strtolower(substr($size['mime'], strpos($size['mime'], '/')+1));
		$icfunc = "imagecreatefrom" . $format;
		if (!function_exists($icfunc)) return false;
		// Создаем новое изображение
		// если автоматом высота, то ширина будет $new_size и наоборот
		$height = ($auto=='height') ? $new_size * $size[1] / $size[0]: $new_size ;
		$width = ($auto=='height') ? $new_size : $new_size * $size[0] / $size[1];
		$idest = imagecreatetruecolor($width, $height);
		$isrc = $icfunc($name_old);
		// Копируем существующее изображение в новое с изменением размера:
		imagecopyresampled(
			$idest,  // Идентификатор нового изображения
			$isrc,  // Идентификатор исходного изображения
			0,0,      // Координаты (x,y) верхнего левого угла
			// в новом изображении
			0,0,      // Координаты (x,y) верхнего левого угла копируемого
			// блока существующего изображения
			$width,     // Новая ширина копируемого блока
			$height,     // Новая высота копируемого блока
			$size[0], // Ширина исходного копируемого блока
			$size[1]  // Высота исходного копируемого блока
		);
		if(imagejpeg($idest, $name_new, $quality)) {
			imagedestroy($isrc);
			imagedestroy($idest);
			return true;
		} else {
			return false;
		}
	}
		
	 /**
		 * v 3.0
		 * Обрезает изображение
		 *
		 * @param string $file_input - имя исходного файла
		 * @param string $file_output - имя генерируемого файла
		 * @param integer $crop - формат обрезки, по умолчанию квадратным делает
		 * @param integer $percent - проценты от исходного
		 * @return bool
		 */
	public function img_crop($file_input, $file_output, $crop = 'square',$percent = false) {
		$debug=true;
		list($w_i, $h_i, $type) = getimagesize($file_input);
		if (!$w_i || !$h_i) {
			if($debug) {die('<div class="notice error" style="font-size:30px;">Не удалось вычислить высоту изображения</div>'); }
			else return false;
		}
		$types = array('','gif','jpeg','png');
		$ext = $types[$type];
		if ($ext) {
			$func = 'imagecreatefrom'.$ext;
			$img = $func($file_input);
		} else {
			if($debug) {die('<div class="notice error" style="font-size:30px;">Не корретный формат файла</div>'); }
			else return false;
		}
		// формат обрезки
		if ($crop == 'square') {
			$min = $w_i;
			if ($w_i > $h_i) $min = $h_i;
			$w_o = $h_o = $min;
			$x_o = $y_o = 0;
		} else {
			list($x_o, $y_o, $w_o, $h_o) = $crop;
			if ($percent) {
				$w_o *= $w_i / 100;
				$h_o *= $h_i / 100;
				$x_o *= $w_i / 100;
				$y_o *= $h_i / 100;
			}
			if ($w_o < 0) $w_o += $w_i;
				$w_o -= $x_o;
			   if ($h_o < 0) $h_o += $h_i;
			$h_o -= $y_o;
		}
		$img_o = imagecreatetruecolor($w_o, $h_o);
		imagecopy($img_o, $img, 0, 0, $x_o, $y_o, $w_o, $h_o);
		if ($type == 2) {
			return imagejpeg($img_o,$file_output,100);
		} else {
			$func = 'image'.$ext;
			return $func($img_o,$file_output);
		}
	}

	
	public function get_rand_name ($length=10,$rand_name=''){
		for ($k=1;$k<=$length;$k++) {
			if ( rand(0, 5)==3 ) {
				$rand_name .= chr(48+rand(0, 9));
			} else {
				$rand_name .= chr(65+rand(0, 25));
			}
		}
		return strtolower($rand_name);
	}
}

