<?php 

class controller_component_core_menus extends component {
	
	public function action_index() {
	
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();
		
		if(isset($this->url['params']['success'])) {
			if($this->url['params']['success']=='add' && isset($this->url['params']['added'])) {
				$this->data['success'][] = 'Меню успешно добавлено<br>';
				$this->data['success'][] = '<a href="' . SITE_URL . '/admin/menus/edit/' . $this->url['params']['added'] . '">Редактировать</a>';
				$this->data['success'][] = '<a href="' . SITE_URL . '/admin/menus/add_items/' . $this->url['params']['added'] . '">Перейти к добавлению элементов меню</a>';
			} elseif($this->url['params']['success']=='edit' && isset($this->url['params']['edited'])) {
				$menu = $this->model->get_menu($this->url['params']['edited']);
				$this->data['success'][] = 'Меню "' . $menu['name'] . '" обновлено<br>';
				$this->data['success'][] = '<a href="' . SITE_URL . '/admin/menus/edit/' . $this->url['params']['edited'] . '">Продолжить редактирование</a>';
				$this->data['success'][] = '<a href="' . SITE_URL . '/admin/menus/add_items/menu_id=' . $this->url['params']['edited'] . '">Перейти к добавлению элементов меню</a>';
			}
		}
		
		$this->data['menus'] = $this->model->get_menus_list();
		
		$this->data['page_name'] = 'Меню сайта';

		$page['title'] = 'Меню сайта';
		$page['keywords'] = 'Меню сайта';
		$page['description'] = 'Меню сайта';
		$page['html'] = $this->load_view();
		
		return $page;
	}
	
	public function action_add() {
	
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();
		
		$menu = array();
		
		if(isset($_POST['menu_name'])) {
			if(!empty($_POST['menu_name'])) {
				$menu['name'] = $_POST['menu_name'];
			} else {
				$menu['name'] = '';
				$this->data['errors'][] = 'Не указано название меню';
			}
		} else {
			$menu['name'] = '';
		}
		
		if(isset($_POST['menu_class'])) {
			$menu['class'] = $_POST['menu_class'];
		} else {
			$menu['class'] = '';
		}
		
		if(isset($_POST['menu_pos'])) {
			$menu['position'] = $_POST['menu_pos'];
		} else {
			$menu['position'] = '';
		}
		
		if(!$this->data['errors'] && isset($_POST['submit'])) {
			if($menu_id = $this->model->add_menu($menu)) {
				$this->redirect(SITE_URL . '/admin/menus/success=add/added=' . $menu_id);
			} else {
				$this->data['notices'][] = 'Не удалось добавить меню.';
			}
		}
		
		$this->data['menu'] = $menu;
		
		$this->data['page_name'] = 'Добавление нового меню';
		$this->data['text_submit'] = 'Добавить';
		$page['title'] = 'Добавление нового меню';
		$page['keywords'] = 'Добавление нового меню';
		$page['description'] = 'Добавление нового меню';
		$page['html'] = $this->load_view('form');
		
		return $page;
	}
	
	public function action_edit() {
	
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();
		
		$menu = array();
		
		if(isset($this->url['actions'][1])) {
			$menu['id'] = $this->url['actions'][1];
		} else {
			$this->redirect(SITE_URL . '/admin/menus');
		}
		
		if(isset($_POST['menu_name'])) {
			if(!empty($_POST['menu_name'])) {
				$menu['name'] = $_POST['menu_name'];
			} else {
				$menu['name'] = '';
				$this->data['errors'][] = 'Не указано название меню';
			}
		} else {
			$menu['name'] = '';
		}
		
		if(isset($_POST['menu_class'])) {
			$menu['class'] = $_POST['menu_class'];
		} else {
			$menu['class'] = '';
		}
		
		if(isset($_POST['menu_pos'])) {
			$menu['position'] = $_POST['menu_pos'];
		} else {
			$menu['position'] = '';
		}
		
		if(!$this->data['errors'] && isset($_POST['submit'])) {
			if($this->model->edit_menu($menu)) {
				$this->redirect(SITE_URL . '/admin/menus/success=edit/edited=' . $menu['id']);
			} else {
				$this->data['notices'][] = 'Не удалось сохранить изменения меню.';
			}
		} else {
			$menu = $this->model->get_menu($menu['id']);
		}
		
		$this->data['menu'] = $menu;
		
		$this->data['page_name'] = 'Редактирования меню "' . $menu['name'] . '"';
		$this->data['text_submit'] = 'Сохранить изменения';
		$page['title'] = 'Добавление нового меню';
		$page['keywords'] = 'Добавление нового меню';
		$page['description'] = 'Добавление нового меню';
		$page['html'] = $this->load_view('form');
		
		return $page;
	}
		
	public function action_delete() {
		if(!isset($this->url['actions'][1])) {
			$this->redirect(SITE_URL . '/admin/menus');
		}
	}
	
	public function action_menu() {
			
		if(!isset($this->url['actions'][1])) {
			$this->redirect(SITE_URL . '/admin/menus');
		}
		
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();

		if(isset($this->url['params']['success'])) {
			if($this->url['params']['success']=='del') {
				$this->data['success'][] = 'Элемент меню удален';
			} elseif($this->url['params']['success']=='add') {
				$this->data['success'][] = 'Элемент добавлен';
			}elseif($this->url['params']['success']=='edit') {
				$this->data['success'][] = 'Изменения сохранены';
			}
		}
		
		$menu_id = $this->url['actions'][1];
		
		$this->data['menu'] = $this->model->get_menu($menu_id);
		$this->data['items'] = $this->model->get_menu_items($menu_id, array('tree'=>true, 'parent_id'=>0, 'sort'=>'sort ASC'));
		
		$this->data['page_name'] = 'Элементы меню "' . $this->data['menu']['name'] . '"';
		//$this->data['text_submit'] = 'Сохранить изменения';
		$page['title'] = 'Элементы меню "' . $this->data['menu']['name'] . '"';
		$page['keywords'] = 'Элементы меню "' . $this->data['menu']['name'] . '"';
		$page['description'] = 'Элементы меню "' . $this->data['menu']['name'] . '"';
		$page['html'] = $this->load_view('items');

		return $page;
	}
	
	public function action_add_item() {
		/*
		if(!isset($this->url['actions']['params'])) {
			$this->redirect(SITE_URL . '/admin/menus');
		}
		*/
		$item = array();
		
		if(isset($this->url['params']['menu_id'])) {
			$item['menu_id'] = $this->url['params']['menu_id'];
		} else {
			$this->redirect(SITE_URL . '/admin/menus');
		}

		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();
		
		if(isset($_POST['item_name'])) {
			if(!empty($_POST['item_name'])) {
				$item['name'] = $_POST['item_name'];
			} else {
				$item['name'] = '';
				$this->data['errors'][] = 'Не указано название элемента меню';
			}
		} else {
			$item['name'] = '';
		}
		
		if(isset($_POST['item_url'])) {
			if(!empty($_POST['item_url'])) {
				$item['url'] = $_POST['item_url'];
			} else {
				$item['url'] = '';
				$this->data['errors'][] = 'Не указан урл';
			}
		} else {
			$item['url'] = '';
		}
		
		if(isset($_POST['item_sort'])) {
			$item['sort'] = $_POST['item_sort'];
		} else {
			$item['sort'] = 0;
		}
		
		if(isset($this->url['params']['parent_id'])) {
			$item['parent_id'] = $this->url['params']['parent_id'];
		} else {
			$item['parent_id'] = 0;
		}
		
		if(!$this->data['errors'] && isset($_POST['submit'])) {
			if($item_id = $this->model->add_menu_item($item)) {
				$this->redirect(SITE_URL . '/admin/menus/menu/'.$item['menu_id'].'/success=add/added=' . $item_id);
				
			} else {
				$this->data['notices'][] = 'Не удалось добавить элемент меню.';
			}
		}
		
		$this->data['item'] = $item;
		
		$this->data['menu'] = $this->model->get_menu($item['menu_id']);
		$this->data['page_name'] = 'Добавление элемента в меню "' . $this->data['menu']['name'] . '"';
		$this->data['text_submit'] = 'Добавить';
		//$this->data['text_submit'] = 'Сохранить изменения';
		$page['title'] = 'Добавление элемента в меню "' . $this->data['menu']['name'] . '"';
		$page['keywords'] = 'Добавление элемента в меню "' . $this->data['menu']['name'] . '"';
		$page['description'] = 'Добавление элемента в меню "' . $this->data['menu']['name'] . '"';
		$page['html'] = $this->load_view('item_form');
		return $page;
	}
	
	public function action_edit_item() {
		
		if(isset($this->url['actions'][1])) {
			$item_id = $this->url['actions'][1];
		} else {
			$this->redirect(SITE_URL . '/admin/menus');
		}
		

		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();
		
		$item = $this->model->get_menu_item($item_id);
		
		if(isset($_POST['item_name'])) {
			if(!empty($_POST['item_name'])) {
				$item['name'] = $_POST['item_name'];
			} else {
				$this->data['errors'][] = 'Не указано название элемента меню';
			}
		} 
		
		if(isset($_POST['item_url'])) {
			if(!empty($_POST['item_url'])) {
				$item['url'] = $_POST['item_url'];
			} else {
				$this->data['errors'][] = 'Не указан урл';
			}
		}
		
		if(isset($_POST['item_sort'])) {
			$item['sort'] = $_POST['item_sort'];
		}
		
		if(!$this->data['errors'] && isset($_POST['submit'])) {
			if($item_id = $this->model->edit_menu_item($item)) {
				$this->redirect(SITE_URL . '/admin/menus/menu/'.$item['menu_id'].'/success=edit');
				
			} else {
				$this->data['notices'][] = 'Не удалось сохранить изменения.';
			}
		}
		
		$this->data['item'] = $item;
		
		$this->data['menu'] = $this->model->get_menu($item['menu_id']);
		$this->data['page_name'] = 'Изменение элемента меню "' . $this->data['menu']['name'] . '"';
		$this->data['text_submit'] = 'Сохранить изменения';
		$page['title'] = 'Изменение элемента меню "' . $this->data['menu']['name'] . '"';
		$page['keywords'] = 'Изменение элемента меню "' . $this->data['menu']['name'] . '"';
		$page['description'] = 'Изменение элемента меню "' . $this->data['menu']['name'] . '"';
		$page['html'] = $this->load_view('item_form');
		return $page;
	}
	
	public function action_delete_item() {
		if(isset($this->url['actions'][1])) {
			$item_id = $this->url['actions'][1];
		} else {
			$this->redirect(SITE_URL . '/admin/menus');
		}
		
		$this->model->delete_menu_item($item_id);
		
		if(isset($this->url['params']['menu_id'])) {
			$this->redirect(SITE_URL . '/admin/menus/menu/' . (int)$this->url['params']['menu_id'] . '/success=del');
		} else {
			$this->redirect(SITE_URL . '/admin/menus');
		}
		
	}
	
}