<?php 

/**
* класс менеджера модулей
*/
class controller_component_core_modules extends component {
	
	// вывод  активированных модулей
	public function action_index() {
		$this->data['success'] = '';
		if(isset($this->url['params']['success'])) {
			if($this->url['params']['success'] == 'deact') {
				$this->data['success'] = 'Модуль успешно деактивирован';
			} elseif($this->url['params']['success'] == 'act') {
				$this->data['success'] = 'Модуль успешно активирован';
			}
		}
		
		$this->data['modules_list'] = $this->model->get_activated_modules();
		//core::print_r($this->data['modules_list']);
		//core::print_r($this->url);

		$this->data['page_name'] = 'Активированные модули';
		$this->page['title'] = 'Активированные модули';
		$this->page['html'] = $this->load_view();

		return $this->page;
	}
	// вывод установленных модулей
	public function action_installed() {
		
		$this->data['modules_list'] = $this->model->get_installed_modules();
		$this->data['page_name'] = 'Установленные Модули';
		$this->page['title'] = 'Установленные Модули';
		$this->page['html'] = $this->load_view('installed');

		return $this->page;
	}
	// установка модулей
	public function action_install() {
		if(isset($_FILES['file'])) {
			if($_FILES['file']['type'] != 'application/zip') {
				$this->data['errors'][] = 'Для установки модуля необходим архив ZIP';
			}
			else {
				$zip = new ZipArchive;
				$zip->open($_FILES['file']['tmp_name']);
				if($zip->getFromName('install.php') === false) {
					$this->data['errors'][] = 'Файла install.php нет в архиве';
				}

				$zip->extractTo(ROOT_DIR . '/modules/');
				$zip->close();
				if(count($this->data['errors']) == 0) {
					//запускаем install.php
					require_once(ROOT_DIR . '/modules/install.php');
					//удаляем install.php
					unlink(ROOT_DIR . '/modules/install.php');
				}
			}
			if(empty($this->data['message']) AND (count($this->data['errors']) == 0) ) {
				$this->data['message'] = 'Сообщение об успешности установки не задано';
			}
		}

		$this->data['page_name'] = 'Установка модулей';
		$this->page['title'] = 'Установка модулей';
		$this->page['html'] = $this->load_view('install');

		return $this->page;
	}
	// обновление модуля
	public function action_update() {
		if(isset($_FILES['file'])) {
			if($_FILES['file']['type'] != 'application/zip') {
				$this->data['errors'][] = 'Для обновления модуля необходим архив ZIP';
			} 
			else {
				$zip = new ZipArchive;
				$zip->open($_FILES['file']['tmp_name']);
				if($zip->getFromName('update.php') === false) {
					$this->data['errors'][] = 'Файла update.php нет в архиве';
				}

				$zip->extractTo(ROOT_DIR . '/modules/');
				$zip->close();
				if(count($this->data['errors']) == 0) {
					//запускаем update.php
					require_once(ROOT_DIR . '/modules/update.php');
					//удаляем update.php
					unlink(ROOT_DIR . '/modules/update.php');
				}
			}
			if(empty($this->data['message']) AND (count($this->data['errors']) == 0) ) {
				$this->data['message'] = 'Сообщение об успешности обновления не задано';
			} 
		}

		$this->data['page_name'] = 'Обновление модуля';
		$this->page['title'] = 'Обновление модуля';
		$this->page['html'] = $this->load_view('update');

		return $this->page;
	}
	// активация модулей
	public function action_activate() {
		
		$module_info = $this->model->get_module_info($this->url['actions'][1]);
		$class_name = 'controller_' . $module_info['type'] . '_' . $module_info['dir'];	
		$obj = new $class_name($this->config, $this->url, $module_info['dir'], $this->dbh);
	
		$page = $obj->action_activate();
		$this->data['params'] = $page['html'];
		
		if(isset($_POST['activate'])) {
			
			$module['name'] = $_POST['name'];
			$module['type'] = $_POST['type'];
			$module['module_id'] = $this->url['actions'][1];
			$module['module_dir'] = $module_info['dir'];
			$module['position'] = $_POST['position'];
			$module['back_end'] = $_POST['back_end'];
			$module['sort'] = '1';
			/*
			if($_POST['page']==2) {
				// на всех кроме
			} else {
				// на выбранных
			}
			*/
			$module['params'] = $page['params'];
			//$module['params'] = '1,2,3,4,5'; // id страниц на которых подключается модуль
			// 3 вкладка выполняем спец задачи по модулю (controller->action_activate)
			
			$num = $this->model->activate_module($module);

			$this->data['message'] = 'Модуль активирован';
		}
		

		$this->data['page_name'] = 'Активация модуля';
		$this->page['title'] = 'Активация модуля';
		$this->page['html'] = $this->load_view('activate');

		return $this->page;
	}
	
	// деактивация модулей
	public function action_deactivate() {
		if(isset($this->url['actions'][1]) && $this->model->deactivate_module($this->url['actions'][1])) {
			$this->redirect(SITE_URL . '/admin/modules/success=deact');
		} else {
			$this->redirect(SITE_URL . '/admin/modules');
		}
	}
	
	// найтройки модуля
	public function action_settings() {
		
	}
	
	public function action_delete() {
		if(isset($this->url['actions'][1])){
			$module_id = $this->url['actions'][1];
			$module = $this->model->get_module_info($module_id);
			$class_name = 'controller_' . $module['type'] . '_' . $module['dir'];
			$module_controller = new $class_name($this->config, $this->url, $module['name'], $this->dbh);
			return $module_controller->action_delete();
		}
	}
}