<?php 

class controller_component_core_gallery extends component {
	
	public function action_index() {
	
		$gallery_info = $this->model->get_component_info('gallery');
		$view = 'categories';
		$not_found = false;
		$categories = $this->model->get_categories();
		
		foreach($categories as $key => $category) {
			if($category['image']){
				$categories[$key]['image'] = SITE_URL . '/uploads/images/portfolio/' . $category['dir'] . '/mini/' . $category['image'];
				$categories[$key]['full'] = SITE_URL . '/uploads/images/portfolio/' . $category['dir'] . '/' . $category['image'];
				$categories[$key]['href'] = SITE_URL . '/' . $gallery_info['url'] . '/' . $category['url'];
			}
		}
		$this->data['categories'] = $categories;
		
		if($not_found) {
			$page['title'] = '404!!1';
			$page['keywords'] = 'Страница не найдена';
			$page['description'] = 'Страница не найдена';
			$this->action_404();
			$view = 'index';
		} else {
			$page['title'] = $gallery_info['title'];
			$page['keywords'] = $gallery_info['keywords'];
			$page['description'] = $gallery_info['description'];
			$this->data['page_name'] = $gallery_info['name'];
			$this->data['bread_crumbs'] = '';
		}

		$page['html'] = $this->load_view($view);
		return $page;
	}
	
	public function action_else() {
		$view = 'category';
		$not_found = false;
		
		$category = $this->model->get_category_by_url($this->url['actions'][0]);
		if($category) {
		
			$this->data['category'] = $category;
			
			$items = $this->model->get_items($category['id']);
			foreach($items as $key => $item) {
				$items[$key]['image'] = SITE_URL . '/uploads/images/portfolio/' . $category['dir'] . '/mini/' . $item['image'];
				$items[$key]['full'] = SITE_URL . '/uploads/images/portfolio/' . $category['dir'] . '/' . $item['image'];
			}
			
			$this->data['items'] = $items;
			
		} else {
			$not_found = true;
		}

		if($not_found) {
			$page['title'] = '404!!1';
			$page['keywords'] = 'Страница не найдена';
			$page['description'] = 'Страница не найдена';
			$this->action_404();
			$view = 'index';
		} else {
			$page['title'] = $category['title'];
			$page['keywords'] = $category['keywords'];
			$page['description'] = $category['description'];
			$this->data['page_name'] = $category['name'];
			$this->data['bread_crumbs'] = '';
		}

		$page['html'] = $this->load_view($view);
		return $page;
	}
}